org.apache.tinkerpop.gremlin.process.computer.bulkloading

## Class BulkLoaderVertexProgram

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.computer.bulkloading.BulkLoaderVertexProgram

- All Implemented Interfaces:
    Cloneable, VertexProgram<Tuple>

  Deprecated.
  As of release 3.2.10, not directly replaced - consider graph provider specific bulk loading methods

      @Deprecated
      public class BulkLoaderVertexProgram
      extends Object
      implements VertexProgram<Tuple>

  Author:
    Daniel Kuppitz (http://gremlin.guru)

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `BulkLoaderVertexProgram.Builder` Deprecated.

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VertexProgram.Features`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `BULK_LOADER_CLASS_CFG_KEY` Deprecated.
    `static String` | `BULK_LOADER_VERTEX_ID_CFG_KEY` Deprecated.
    `static String` | `BULK_LOADER_VERTEX_PROGRAM_CFG_PREFIX` Deprecated.
    `static String` | `DEFAULT_BULK_LOADER_VERTEX_ID` Deprecated.
    `static String` | `INTERMEDIATE_BATCH_SIZE_CFG_KEY` Deprecated.
    `static String` | `KEEP_ORIGINAL_IDS_CFG_KEY` Deprecated.
    `static String` | `USER_SUPPLIED_IDS_CFG_KEY` Deprecated.
    `static String` | `WRITE_GRAPH_CFG_KEY` Deprecated.

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VERTEX_PROGRAM`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static BulkLoaderVertexProgram.Builder` | `build()` Deprecated.
    `VertexProgram<Tuple>` | `clone()` Deprecated. When multiple workers on a single machine need VertexProgram instances, it is possible to use clone.
    `void` | `execute(Vertex sourceVertex, Messenger<Tuple> messenger, Memory memory)` Deprecated. This method denotes the main body of the computation and is executed on each vertex in the graph.
    `VertexProgram.Features` | `getFeatures()` Deprecated.
    `Set<MessageScope>` | `getMessageScopes(Memory memory)` Deprecated. This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program.
    `GraphComputer.Persist` | `getPreferredPersist()` Deprecated.
    `GraphComputer.ResultGraph` | `getPreferredResultGraph()` Deprecated.
    `Set<VertexComputeKey>` | `getVertexComputeKeys()` Deprecated. The `Element` properties that will be mutated during the computation.
    `void` | `loadState(Graph graph, Configuration config)` Deprecated. When it is necessary to load the state of the VertexProgram, this method is called.
    `void` | `setup(Memory memory)` Deprecated. The method is called at the beginning of the computation.
    `void` | `storeState(Configuration config)` Deprecated. When it is necessary to store the state of the VertexProgram, this method is called.
    `boolean` | `terminate(Memory memory)` Deprecated. The method is called at the end of each iteration to determine if the computation is complete.
    `String` | `toString()` Deprecated.
    `void` | `workerIterationEnd(Memory memory)` Deprecated. This method is called at the end of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism.
    `void` | `workerIterationStart(Memory memory)` Deprecated. This method is called at the start of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `createVertexProgram, getMapReducers, getMemoryComputeKeys, getMessageCombiner, getTraverserRequirements`

- - ### Field Detail

    - #### BULK_LOADER_VERTEX_PROGRAM_CFG_PREFIX

          public static final String BULK_LOADER_VERTEX_PROGRAM_CFG_PREFIX

      Deprecated.
      See Also:
        Constant Field Values

    - #### BULK_LOADER_CLASS_CFG_KEY

          public static final String BULK_LOADER_CLASS_CFG_KEY

      Deprecated.

    - #### BULK_LOADER_VERTEX_ID_CFG_KEY

          public static final String BULK_LOADER_VERTEX_ID_CFG_KEY

      Deprecated.

    - #### INTERMEDIATE_BATCH_SIZE_CFG_KEY

          public static final String INTERMEDIATE_BATCH_SIZE_CFG_KEY

      Deprecated.

    - #### KEEP_ORIGINAL_IDS_CFG_KEY

          public static final String KEEP_ORIGINAL_IDS_CFG_KEY

      Deprecated.

    - #### USER_SUPPLIED_IDS_CFG_KEY

          public static final String USER_SUPPLIED_IDS_CFG_KEY

      Deprecated.

    - #### WRITE_GRAPH_CFG_KEY

          public static final String WRITE_GRAPH_CFG_KEY

      Deprecated.

    - #### DEFAULT_BULK_LOADER_VERTEX_ID

          public static final String DEFAULT_BULK_LOADER_VERTEX_ID

      Deprecated.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### setup

          public void setup(Memory memory)

      Deprecated.
      Description copied from interface: `VertexProgram`
      The method is called at the beginning of the computation. The method is global to the `GraphComputer` and as such, is not called for each vertex. During this stage, the `Memory` should be initialized to to its "start state."
      Specified by:
        `setup` in interface `VertexProgram<Tuple>`
      Parameters:
        `memory` - The global memory of the GraphComputer

    - #### loadState

          public void loadState(Graph graph,
                                Configuration config)

      Deprecated.
      Description copied from interface: `VertexProgram`
      When it is necessary to load the state of the VertexProgram, this method is called. This is typically required when the VertexProgram needs to be serialized to another machine. Note that what is loaded is simply the instance state, not any processed data.
      Specified by:
        `loadState` in interface `VertexProgram<Tuple>`
      Parameters:
        `graph` - the graph that the VertexProgram will run against
        `config` - the configuration to load the state of the VertexProgram from.

    - #### storeState

          public void storeState(Configuration config)

      Deprecated.
      Description copied from interface: `VertexProgram`
      When it is necessary to store the state of the VertexProgram, this method is called. This is typically required when the VertexProgram needs to be serialized to another machine. Note that what is stored is simply the instance/configuration state, not any processed data. The default implementation provided simply stores the VertexProgram class name for reflective reconstruction. It is typically a good idea to VertexProgram.super.storeState().
      Specified by:
        `storeState` in interface `VertexProgram<Tuple>`
      Parameters:
        `config` - the configuration to store the state of the VertexProgram in.

    - #### workerIterationStart

          public void workerIterationStart(Memory memory)

      Deprecated.
      Description copied from interface: `VertexProgram`
      This method is called at the start of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism. The vertex set is split into subsets and a worker is assigned to call the `VertexProgram.execute(org.apache.tinkerpop.gremlin.structure.Vertex, org.apache.tinkerpop.gremlin.process.computer.Messenger<M>, org.apache.tinkerpop.gremlin.process.computer.Memory)` method. The default implementation is a no-op.
      Specified by:
        `workerIterationStart` in interface `VertexProgram<Tuple>`
      Parameters:
        `memory` - The memory at the start of the iteration.

    - #### workerIterationEnd

          public void workerIterationEnd(Memory memory)

      Deprecated.
      Description copied from interface: `VertexProgram`
      This method is called at the end of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism. The vertex set is split into subsets and a worker is assigned to call the `VertexProgram.execute(org.apache.tinkerpop.gremlin.structure.Vertex, org.apache.tinkerpop.gremlin.process.computer.Messenger<M>, org.apache.tinkerpop.gremlin.process.computer.Memory)` method. The default implementation is a no-op.
      Specified by:
        `workerIterationEnd` in interface `VertexProgram<Tuple>`
      Parameters:
        `memory` - The memory at the end of the iteration.

    - #### execute

          public void execute(Vertex sourceVertex,
                              Messenger<Tuple> messenger,
                              Memory memory)

      Deprecated.
      Description copied from interface: `VertexProgram`
      This method denotes the main body of the computation and is executed on each vertex in the graph. This method is logically executed in parallel on all vertices in the graph. When the `Memory` is read, it is according to the aggregated state yielded in the previous iteration. When the `Memory` is written, the data will be aggregated at the end of the iteration for reading in the next iteration.
      Specified by:
        `execute` in interface `VertexProgram<Tuple>`
      Parameters:
        `sourceVertex` - the `Vertex` to execute the `VertexProgram` on
        `messenger` - the messenger that moves data between vertices
        `memory` - the shared state between all vertices in the computation

    - #### terminate

          public boolean terminate(Memory memory)

      Deprecated.
      Description copied from interface: `VertexProgram`
      The method is called at the end of each iteration to determine if the computation is complete. The method is global to the `GraphComputer` and as such, is not called for each `Vertex`. The `Memory` maintains the aggregated data from the last execute() iteration.
      Specified by:
        `terminate` in interface `VertexProgram<Tuple>`
      Parameters:
        `memory` - The global memory of the `GraphComputer`
      Returns:
        whether or not to halt the computation

    - #### getVertexComputeKeys

          public Set<VertexComputeKey> getVertexComputeKeys()

      Deprecated.
      Description copied from interface: `VertexProgram`
      The `Element` properties that will be mutated during the computation. All properties in the graph are readable, but only the keys specified here are writable. The default is an empty set.
      Specified by:
        `getVertexComputeKeys` in interface `VertexProgram<Tuple>`
      Returns:
        the set of element keys that will be mutated during the vertex program's execution

    - #### getMessageScopes

          public Set<MessageScope> getMessageScopes(Memory memory)

      Deprecated.
      Description copied from interface: `VertexProgram`
      This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program. The returned messages scopes are the scopes that will be used to send messages during the stated iteration. It is not a requirement that all stated messages scopes be used, just that it is possible that they be used during the iteration.
      Specified by:
        `getMessageScopes` in interface `VertexProgram<Tuple>`
      Parameters:
        `memory` - an immutable form of the `Memory`
      Returns:
        all possible message scopes during said vertex program iteration

    - #### clone

          public VertexProgram<Tuple> clone()

      Deprecated.
      Description copied from interface: `VertexProgram`
      When multiple workers on a single machine need VertexProgram instances, it is possible to use clone. This will provide a speedier way of generating instances, over the `VertexProgram.storeState(Configuration)` and `VertexProgram.loadState(org.apache.tinkerpop.gremlin.structure.Graph, Configuration)` model. The default implementation simply returns the object as it assumes that the VertexProgram instance is a stateless singleton.
      Specified by:
        `clone` in interface `VertexProgram<Tuple>`
      Overrides:
        `clone` in class `Object`
      Returns:
        A clone of the VertexProgram object

    - #### getPreferredResultGraph

          public GraphComputer.ResultGraph getPreferredResultGraph()

      Deprecated.
      Specified by:
        `getPreferredResultGraph` in interface `VertexProgram<Tuple>`

    - #### getPreferredPersist

          public GraphComputer.Persist getPreferredPersist()

      Deprecated.
      Specified by:
        `getPreferredPersist` in interface `VertexProgram<Tuple>`

    - #### toString

          public String toString()

      Deprecated.
      Overrides:
        `toString` in class `Object`

    - #### build

          public static BulkLoaderVertexProgram.Builder build()

      Deprecated.

    - #### getFeatures

          public VertexProgram.Features getFeatures()

      Deprecated.
      Specified by:
        `getFeatures` in interface `VertexProgram<Tuple>`

Copyright © 2013–2020 Apache Software Foundation. All rights reserved.